const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const analytics_events = sequelize.define(
    'analytics_events',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      event_type: {
        type: DataTypes.ENUM,

        values: ['VISIT', 'CLICK'],
      },

      referrer: {
        type: DataTypes.TEXT,
      },

      user_agent: {
        type: DataTypes.TEXT,
      },

      ip_hash: {
        type: DataTypes.TEXT,
      },

      occurred_at: {
        type: DataTypes.DATE,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  analytics_events.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.analytics_events.belongsTo(db.profile_pages, {
      as: 'profile_page',
      foreignKey: {
        name: 'profile_pageId',
      },
      constraints: false,
    });

    db.analytics_events.belongsTo(db.button_links, {
      as: 'link',
      foreignKey: {
        name: 'linkId',
      },
      constraints: false,
    });

    db.analytics_events.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.analytics_events.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.analytics_events.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return analytics_events;
};
